/*******************************************************************************
* File Name: RISR.h
* Version 1.70
*
*  Description:
*   Provides the function definitions for the Interrupt Controller.
*
*
********************************************************************************
* Copyright 2008-2015, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
*******************************************************************************/
#if !defined(CY_ISR_RISR_H)
#define CY_ISR_RISR_H


#include <cytypes.h>
#include <cyfitter.h>

/* Interrupt Controller API. */
void RISR_Start(void);
void RISR_StartEx(cyisraddress address);
void RISR_Stop(void);

CY_ISR_PROTO(RISR_Interrupt);

void RISR_SetVector(cyisraddress address);
cyisraddress RISR_GetVector(void);

void RISR_SetPriority(uint8 priority);
uint8 RISR_GetPriority(void);

void RISR_Enable(void);
uint8 RISR_GetState(void);
void RISR_Disable(void);

void RISR_SetPending(void);
void RISR_ClearPending(void);


/* Interrupt Controller Constants */

/* Address of the INTC.VECT[x] register that contains the Address of the RISR ISR. */
#define RISR_INTC_VECTOR            ((reg32 *) RISR__INTC_VECT)

/* Address of the RISR ISR priority. */
#define RISR_INTC_PRIOR             ((reg8 *) RISR__INTC_PRIOR_REG)

/* Priority of the RISR interrupt. */
#define RISR_INTC_PRIOR_NUMBER      RISR__INTC_PRIOR_NUM

/* Address of the INTC.SET_EN[x] byte to bit enable RISR interrupt. */
#define RISR_INTC_SET_EN            ((reg32 *) RISR__INTC_SET_EN_REG)

/* Address of the INTC.CLR_EN[x] register to bit clear the RISR interrupt. */
#define RISR_INTC_CLR_EN            ((reg32 *) RISR__INTC_CLR_EN_REG)

/* Address of the INTC.SET_PD[x] register to set the RISR interrupt state to pending. */
#define RISR_INTC_SET_PD            ((reg32 *) RISR__INTC_SET_PD_REG)

/* Address of the INTC.CLR_PD[x] register to clear the RISR interrupt. */
#define RISR_INTC_CLR_PD            ((reg32 *) RISR__INTC_CLR_PD_REG)


#endif /* CY_ISR_RISR_H */


/* [] END OF FILE */
